package pt.uc.dei.wsst.services.bank;

import static pt.uc.dei.wsst.services.Util.*;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;

import javax.jws.WebMethod;
import javax.jws.WebParam;
import javax.jws.WebService;

/**
 * Ready to test:
 * - NPE checked
 * - Domains defined
 *
 * 
 *
 * @author $Author: $
 */
@WebService
public class Bank {

    static int numd;
    static int numf;
    static int nume;

    /**
     *
     * @param stra "Please enter the NAME to open a CURRENT ACCOUNT"
     * @param strb "Please enter the ACCOUNT NUMBER"
     * @return
     */
    @WebMethod(operationName = "create")
    public String create(
            @WebParam(targetNamespace = "http://bank.services.wsst.dei.uc.pt/", name = "stra") String stra,
            @WebParam(targetNamespace = "http://bank.services.wsst.dei.uc.pt/", name = "strb") String strb) {
        if (stra == null || strb == null) {
            return "Either any one or both the values were left blank";
        } else {
            Connection con = null;
            try {
                con = getOdbcConnection("bank");
                Statement st2 = con.createStatement();
                String rr = "insert into tab1 values('" + stra + "','" + strb + "',0,0,0)";
                st2.executeUpdate(rr); //@findbugs
                st2.close();
                close(con);
                return "ACCOUNT Created Successfully";
            } catch (Exception e2) {
                close(con);
                return "There is already a user with same ACCOUNT NUMBER, Give another ACCOUNT NUMBER";
            }
        }
    }

    @WebMethod(operationName = "sign")
    public String[] sign(
            @WebParam(targetNamespace = "http://bank.services.wsst.dei.uc.pt/", name = "num") String num) {
        Connection con = null;
        try {
            con = getOdbcConnection("bank");
            Statement st1 = con.createStatement();
            ResultSet rs1 = st1.executeQuery("Select * from tab1 where AccNum Like '" + num + "'");//@findbugs
            rs1.next();
            String[] ret = new String[]{rs1.getString("AccNum"), rs1.getString("UserName")};
            close(con);
            return ret;
        } catch (Exception e2) {
            close(con);
            return new String[]{"Invalid Account Number"};
        }
    }

    /**
     *
     * @param accnum
     * @param amountDeposit >0
     * @return
     */
    @WebMethod(operationName = "deposit")
    public String deposit(
            @WebParam(targetNamespace = "http://bank.services.wsst.dei.uc.pt/", name = "accnum") String accnum,
            @WebParam(targetNamespace = "http://bank.services.wsst.dei.uc.pt/", name = "amountDeposit") String amountDeposit) {
        numd = Integer.parseInt(amountDeposit);
        int numb = Integer.parseInt(accnum);
        if (numd <= 0) {
            return " NO Amount Deposited";
        } else {
            Connection con = null;
            try {
                int num, num1;
                con = getOdbcConnection("bank");
                Statement st3 = con.createStatement();
                ResultSet rs1 = st3.executeQuery("select * from tab1 where Accnum like '" + accnum + "'");//@findbugs False Positive
                rs1.next();
                num1 = Integer.parseInt(rs1.getString("Deposit"));
                num = Integer.parseInt(rs1.getString("Balance"));
                numf = num + numd /*+ 100*/;
                num1 = num1 + numd;
                Statement st2 = con.createStatement();
                String ss = "update tab1 set Deposit=" + num1 + " where AccNum=" + numb + "";
                String aa = "update tab1 set Balance=" + numf + " where AccNum=" + numb + "";
                st2.executeUpdate(ss);
                st2.executeUpdate(aa);
                st2.close();
                st3.close();
                close(con);
                return "Amount Deposited Successfully , Amount is " + numd;
            } catch (Exception e2) {
                close(con);
                return "Amount cannot be DEPOSITED";
            }
        }
    }

    /**
     *
     * @param accnum
     * @param amountToWithdraw [1-10]
     * @return
     */
    @WebMethod(operationName = "withdraw")
    public String withdraw(
            @WebParam(targetNamespace = "http://bank.services.wsst.dei.uc.pt/", name = "accnum") String accnum,
            @WebParam(targetNamespace = "http://bank.services.wsst.dei.uc.pt/", name = "amountToWithdraw") String amountToWithdraw) {
        nume = Integer.parseInt(amountToWithdraw);
        int numc = Integer.parseInt(accnum);
        if (numf /*+ 100*/ <= nume) {
            return "Sorry can not Withdraw, no sufficient Balance";
        } else {
            Connection con = null;
            try {
                con = getOdbcConnection("bank");
                Statement st3 = con.createStatement();
                ResultSet rs1 = st3.executeQuery("select * from tab1 where Accnum like '" + accnum + "'");//@findbugs F.P.
                rs1.next();
                int num1 = Integer.parseInt(rs1.getString("Withdraw"));
                numf = Integer.parseInt(rs1.getString("Balance"));
                numf = numf - nume;
                num1 = num1 + nume;
                Statement st2 = con.createStatement();
                String pp = "update tab1 set Withdraw=" + num1 + " where AccNum=" + numc + "";
                String pp1 = "update tab1 set Balance=" + numf + " where AccNum=" + numc + "";
                st2.executeUpdate(pp);
                st2.executeUpdate(pp1);
                st2.close();
                close(con);
                return "Amount Withdrawn is " + nume;
            } catch (Exception e2) {
                close(con);
                return "Cannot WITHDRAW ";
            }
        }
    }

    @WebMethod(operationName = "balance")
    public String balance(
            @WebParam(targetNamespace = "http://bank.services.wsst.dei.uc.pt/", name = "num") String num) {
        Connection con = null;
        try {
            con = getOdbcConnection("bank");
            Statement st3 = con.createStatement();
            ResultSet rs1 = st3.executeQuery("select * from tab1 where Accnum like \'" + num + "\'");//@findbugs
            rs1.next();
            numf = Integer.parseInt(rs1.getString("Balance")) /*+ 100*/;
            close(con);
            return "Balance is " + numf;
        } catch (Exception e2) {
            close(con);
            return " Balance null ";
        }
    }
}